//---------------------------------------------------------------------------
//
//   MQInit.cpp      Copyright(C) 1999-2000, O.Mizno
//
//    @Metasequoia SDK Rev0.07̎dlɊÂ֐`ĂB
//    vOCJ҂̃t@C̓eύXKv͂ȂB
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include "MQPlugin.h"


// global
HWND (__stdcall *MQ_GetWindowHandle)(void);
MQObject (__stdcall *MQ_CreateObject)(void);
MQMaterial (__stdcall *MQ_CreateMaterial)(void);
void (__stdcall *MQ_ShowFileDialog)(const char *title, MQFileDialogInfo *info);
void (__stdcall *MQ_ImportAxis)(MQFileDialogInfo *info, MQPoint *pts, int pts_count);
void (__stdcall *MQ_ExportAxis)(MQFileDialogInfo *info, MQPoint *pts, int pts_count);

// class MQDodument
int  (__stdcall *MQDoc_GetObjectCount)(MQDocument doc);
MQObject (__stdcall *MQDoc_GetObject)(MQDocument doc, int index);
int  (__stdcall *MQDoc_GetCurrentObjectIndex)(MQDocument doc);
void (__stdcall *MQDoc_SetCurrentObjectIndex)(MQDocument doc, int index);
int  (__stdcall *MQDoc_AddObject)(MQDocument doc, MQObject obj);
void (__stdcall *MQDoc_DeleteObject)(MQDocument doc, int index);
int  (__stdcall *MQDoc_GetObjectIndex)(MQDocument doc, MQObject obj);
int  (__stdcall *MQDoc_GetMaterialCount)(MQDocument doc);
MQMaterial (__stdcall *MQDoc_GetMaterial)(MQDocument doc, int material);
int  (__stdcall *MQDoc_GetCurrentMaterialIndex)(MQDocument doc);
void (__stdcall *MQDoc_SetCurrentMaterialIndex)(MQDocument doc, int index);
int  (__stdcall *MQDoc_AddMaterial)(MQDocument doc, MQMaterial mat);
void (__stdcall *MQDoc_DeleteMaterial)(MQDocument doc, int index);
void (__stdcall *MQDoc_Compact)(MQDocument doc);
void (__stdcall *MQDoc_ClearSelect)(MQDocument doc, DWORD flag);
BOOL (__stdcall *MQDoc_AddSelectVertex)(MQDocument doc, int objindex, int vertindex);
BOOL (__stdcall *MQDoc_DeleteSelectVertex)(MQDocument doc, int objindex, int vertindex);
BOOL (__stdcall *MQDoc_IsSelectVertex)(MQDocument doc, int objindex, int vertindex);
BOOL (__stdcall *MQDoc_AddSelectLine)(MQDocument doc, int objindex, int faceindex, int lineindex);
BOOL (__stdcall *MQDoc_DeleteSelectLine)(MQDocument doc, int objindex, int faceindex, int lineindex);
BOOL (__stdcall *MQDoc_IsSelectLine)(MQDocument doc, int objindex, int faceindex, int lineindex);
BOOL (__stdcall *MQDoc_AddSelectFace)(MQDocument doc, int objindex, int faceindex);
BOOL (__stdcall *MQDoc_DeleteSelectFace)(MQDocument doc, int objindex, int faceindex);
BOOL (__stdcall *MQDoc_IsSelectFace)(MQDocument doc, int objindex, int faceindex);

// class MQObject
void (__stdcall *MQObj_Delete)(MQObject obj);
MQObject (__stdcall *MQObj_Clone)(MQObject obj);
void (__stdcall *MQObj_Merge)(MQObject dest, MQObject source);
void (__stdcall *MQObj_Freeze)(MQObject obj, DWORD flag);
void (__stdcall *MQObj_GetName)(MQObject obj, char *buffer, int size);
int  (__stdcall *MQObj_GetVertexCount)(MQObject obj);
void (__stdcall *MQObj_GetVertex)(MQObject obj, int index, MQPoint *pts);
void (__stdcall *MQObj_SetVertex)(MQObject obj, int index, MQPoint *pts);
void (__stdcall *MQObj_GetVertexArray)(MQObject obj, MQPoint *ptsarray);
int  (__stdcall *MQObj_GetFaceCount)(MQObject obj);
int  (__stdcall *MQObj_GetFacePointCount)(MQObject obj, int face);
void (__stdcall *MQObj_GetFacePointArray)(MQObject obj, int face, int *vertex);
void (__stdcall *MQObj_GetFaceCoordinateArray)(MQObject obj, int face, MQCoordinate *uvarray);
int  (__stdcall *MQObj_GetFaceMaterial)(MQObject obj, int face);
void (__stdcall *MQObj_SetName)(MQObject obj, const char *buffer);
int  (__stdcall *MQObj_AddVertex)(MQObject obj, MQPoint *p);
BOOL (__stdcall *MQObj_DeleteVertex)(MQObject obj, int index, BOOL del_vert);
int  (__stdcall *MQObj_GetVertexRefCount)(MQObject obj, int index);
DWORD (__stdcall *MQObj_GetVertexColor)(MQObject obj, int index);
void (__stdcall *MQObj_SetVertexColor)(MQObject obj, int index, DWORD color);
float (__stdcall *MQObj_GetVertexWeight)(MQObject obj, int index);
void (__stdcall *MQObj_SetVertexWeight)(MQObject obj, int index, float value);
void (__stdcall *MQObj_CopyVertexAttribute)(MQObject obj, int vert1, MQObject obj2, int vert2);
int  (__stdcall *MQObj_AddFace)(MQObject obj, int count, int *index);
BOOL (__stdcall *MQObj_DeleteFace)(MQObject obj, int index, BOOL del_vert);
BOOL (__stdcall *MQObj_InvertFace)(MQObject obj, int index);
void (__stdcall *MQObj_SetFaceMaterial)(MQObject obj, int face, int material);
void (__stdcall *MQObj_SetFaceCoordinateArray)(MQObject obj, int face, MQCoordinate *uvarray);
void (__stdcall *MQObj_OptimizeVertex)(MQObject obj, float distance, MQBool *apply);
void (__stdcall *MQObj_Compact)(MQObject obj);
DWORD (__stdcall *MQObj_GetVisible)(MQObject obj);
void (__stdcall *MQObj_SetVisible)(MQObject obj, DWORD visible);
DWORD (__stdcall *MQObj_GetPatchType)(MQObject obj);
void (__stdcall *MQObj_SetPatchType)(MQObject obj, DWORD type);
int  (__stdcall *MQObj_GetPatchSegment)(MQObject obj);
void (__stdcall *MQObj_SetPatchSegment)(MQObject obj, int segment);

// class MQMaterial
void (__stdcall *MQMat_Delete)(MQMaterial mat);
void (__stdcall *MQMat_GetName)(MQMaterial mat, char *buffer, int size);
void (__stdcall *MQMat_GetColor)(MQMaterial mat, MQColor *color);
float (__stdcall *MQMat_GetAlpha)(MQMaterial mat);
float (__stdcall *MQMat_GetDiffuse)(MQMaterial mat);
float (__stdcall *MQMat_GetAmbient)(MQMaterial mat);
float (__stdcall *MQMat_GetEmission)(MQMaterial mat);
float (__stdcall *MQMat_GetSpecular)(MQMaterial mat);
float (__stdcall *MQMat_GetPower)(MQMaterial mat);
void (__stdcall *MQMat_GetTextureName)(MQMaterial mat, char *buffer, int size);
void (__stdcall *MQMat_GetAlphaName)(MQMaterial mat, char *buffer, int size);
void (__stdcall *MQMat_GetBumpName)(MQMaterial mat, char *buffer, int size);
void (__stdcall *MQMat_SetName)(MQMaterial mat, const char *name);
void (__stdcall *MQMat_SetColor)(MQMaterial mat, MQColor *color);
void (__stdcall *MQMat_SetAlpha)(MQMaterial mat, float value);
void (__stdcall *MQMat_SetDiffuse)(MQMaterial mat, float value);
void (__stdcall *MQMat_SetAmbient)(MQMaterial mat, float value);
void (__stdcall *MQMat_SetEmission)(MQMaterial mat, float value);
void (__stdcall *MQMat_SetSpecular)(MQMaterial mat, float value);
void (__stdcall *MQMat_SetPower)(MQMaterial mat, float value);
void (__stdcall *MQMat_SetTextureName)(MQMaterial mat, const char *name);
void (__stdcall *MQMat_SetAlphaName)(MQMaterial mat, const char *name);
void (__stdcall *MQMat_SetBumpName)(MQMaterial mat, const char *name);



MQPLUGIN_EXPORT DWORD MQCheckVersion(DWORD exe_version)
{
	// exẽo[W1.9.9.5(Ver2.0 RC5)ȏKv
	if(exe_version < 0x1995)
		return 0;

	// ̃vOCRev0.07ɊÂdl
	return 0x007;
}

MQPLUGIN_EXPORT BOOL MQInit(const char *exe_name)
{
	HMODULE hModule = LoadLibrary(exe_name);
	if(hModule == NULL)
		return FALSE;

	BOOL result = FALSE;

#define GPA(proc,name) \
	*(FARPROC *)&proc = GetProcAddress(hModule, name); \
	if(proc == NULL) goto MQINIT_EXIT;

	GPA(MQ_GetWindowHandle, "MQ_GetWindowHandle");
	GPA(MQ_CreateObject, "MQ_CreateObject");
	GPA(MQ_CreateMaterial, "MQ_CreateMaterial");
	GPA(MQ_ShowFileDialog, "MQ_ShowFileDialog");
	GPA(MQ_ImportAxis, "MQ_ImportAxis");
	GPA(MQ_ExportAxis, "MQ_ExportAxis");

	GPA(MQDoc_GetObjectCount, "MQDoc_GetObjectCount");
	GPA(MQDoc_GetObject,   "MQDoc_GetObject");
	GPA(MQDoc_GetCurrentObjectIndex,   "MQDoc_GetCurrentObjectIndex");
	GPA(MQDoc_SetCurrentObjectIndex,   "MQDoc_SetCurrentObjectIndex");
	GPA(MQDoc_AddObject, "MQDoc_AddObject");
	GPA(MQDoc_DeleteObject, "MQDoc_DeleteObject");
	GPA(MQDoc_GetObjectIndex, "MQDoc_GetObjectIndex");
	GPA(MQDoc_GetMaterialCount, "MQDoc_GetMaterialCount");
	GPA(MQDoc_GetMaterial, "MQDoc_GetMaterial");
	GPA(MQDoc_GetCurrentMaterialIndex, "MQDoc_GetCurrentMaterialIndex");
	GPA(MQDoc_SetCurrentMaterialIndex, "MQDoc_SetCurrentMaterialIndex");
	GPA(MQDoc_AddMaterial, "MQDoc_AddMaterial");
	GPA(MQDoc_DeleteMaterial, "MQDoc_DeleteMaterial");
	GPA(MQDoc_Compact, "MQDoc_Compact");
	GPA(MQDoc_ClearSelect, "MQDoc_ClearSelect");
	GPA(MQDoc_AddSelectVertex, "MQDoc_AddSelectVertex");
	GPA(MQDoc_DeleteSelectVertex, "MQDoc_DeleteSelectVertex");
	GPA(MQDoc_IsSelectVertex, "MQDoc_IsSelectVertex");
	GPA(MQDoc_AddSelectLine, "MQDoc_AddSelectLine");
	GPA(MQDoc_DeleteSelectLine, "MQDoc_DeleteSelectLine");
	GPA(MQDoc_IsSelectLine, "MQDoc_IsSelectLine");
	GPA(MQDoc_AddSelectFace, "MQDoc_AddSelectFace");
	GPA(MQDoc_DeleteSelectFace, "MQDoc_DeleteSelectFace");
	GPA(MQDoc_IsSelectFace, "MQDoc_IsSelectFace");

	GPA(MQObj_Delete, "MQObj_Delete");
	GPA(MQObj_Clone, "MQObj_Clone");
	GPA(MQObj_Merge, "MQObj_Merge");
	GPA(MQObj_Freeze, "MQObj_Freeze");
	GPA(MQObj_GetName, "MQObj_GetName");
	GPA(MQObj_GetVertexCount, "MQObj_GetVertexCount");
	GPA(MQObj_GetVertex, "MQObj_GetVertex");
	GPA(MQObj_SetVertex, "MQObj_SetVertex");
	GPA(MQObj_GetVertexArray, "MQObj_GetVertexArray");
	GPA(MQObj_GetFaceCount, "MQObj_GetFaceCount");
	GPA(MQObj_GetFacePointCount, "MQObj_GetFacePointCount");
	GPA(MQObj_GetFacePointArray, "MQObj_GetFacePointArray");
	GPA(MQObj_GetFaceCoordinateArray, "MQObj_GetFaceCoordinateArray");
	GPA(MQObj_GetFaceMaterial, "MQObj_GetFaceMaterial");
	GPA(MQObj_SetName, "MQObj_SetName");
	GPA(MQObj_AddVertex, "MQObj_AddVertex");
	GPA(MQObj_DeleteVertex, "MQObj_DeleteVertex");
	GPA(MQObj_GetVertexRefCount, "MQObj_GetVertexRefCount");
	GPA(MQObj_GetVertexColor, "MQObj_GetVertexColor");
	GPA(MQObj_SetVertexColor, "MQObj_SetVertexColor");
	GPA(MQObj_GetVertexWeight, "MQObj_GetVertexWeight");
	GPA(MQObj_SetVertexWeight, "MQObj_SetVertexWeight");
	GPA(MQObj_CopyVertexAttribute, "MQObj_CopyVertexAttribute");
	GPA(MQObj_AddFace, "MQObj_AddFace");
	GPA(MQObj_DeleteFace, "MQObj_DeleteFace");
	GPA(MQObj_InvertFace, "MQObj_InvertFace");
	GPA(MQObj_SetFaceMaterial, "MQObj_SetFaceMaterial");
	GPA(MQObj_SetFaceCoordinateArray, "MQObj_SetFaceCoordinateArray");
	GPA(MQObj_OptimizeVertex, "MQObj_OptimizeVertex");
	GPA(MQObj_Compact, "MQObj_Compact");
	GPA(MQObj_GetVisible, "MQObj_GetVisible");
	GPA(MQObj_SetVisible, "MQObj_SetVisible");
	GPA(MQObj_GetPatchType, "MQObj_GetPatchType");
	GPA(MQObj_SetPatchType, "MQObj_SetPatchType");
	GPA(MQObj_GetPatchSegment, "MQObj_GetPatchSegment");
	GPA(MQObj_SetPatchSegment, "MQObj_SetPatchSegment");

	GPA(MQMat_Delete,      "MQMat_Delete");
	GPA(MQMat_GetName,     "MQMat_GetName");
	GPA(MQMat_GetColor,    "MQMat_GetColor");
	GPA(MQMat_GetAlpha,    "MQMat_GetAlpha");
	GPA(MQMat_GetDiffuse,  "MQMat_GetDiffuse");
	GPA(MQMat_GetAmbient,  "MQMat_GetAmbient");
	GPA(MQMat_GetEmission, "MQMat_GetEmission");
	GPA(MQMat_GetSpecular, "MQMat_GetSpecular");
	GPA(MQMat_GetPower,    "MQMat_GetPower");
	GPA(MQMat_GetTextureName, "MQMat_GetTextureName");
	GPA(MQMat_GetAlphaName, "MQMat_GetAlphaName");
	GPA(MQMat_GetBumpName, "MQMat_GetBumpName");
	GPA(MQMat_SetName,     "MQMat_SetName");
	GPA(MQMat_SetColor,    "MQMat_SetColor");
	GPA(MQMat_SetAlpha,    "MQMat_SetAlpha");
	GPA(MQMat_SetDiffuse,  "MQMat_SetDiffuse");
	GPA(MQMat_SetAmbient,  "MQMat_SetAmbient");
	GPA(MQMat_SetEmission, "MQMat_SetEmission");
	GPA(MQMat_SetSpecular, "MQMat_SetSpecular");
	GPA(MQMat_SetPower,    "MQMat_SetPower");
	GPA(MQMat_SetTextureName, "MQMat_SetTextureName");
	GPA(MQMat_SetAlphaName, "MQMat_SetAlphaName");
	GPA(MQMat_SetBumpName, "MQMat_SetBumpName");

	result = TRUE;

MQINIT_EXIT:
	FreeLibrary(hModule);
	return result;
}


